// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	"LAPP_ACURA_MOM_BACKEND/grmi"
	meta "LAPP_ACURA_MOM_BACKEND/meta/report"
	model "LAPP_ACURA_MOM_BACKEND/models/report"
	"fmt"
	"github.com/go-xorm/xorm"
	"xorm.io/core"
)

/******************************************************************************
*
* @Struct Name              : FilterDataInfoDAOImplement
*-----------------------------------------------------------------------------
*
* @Description              : FilterDataInfo的数据访问对象实现
*
* @Author                   : 代码生成器创建
*
* @Date                     : 2021-06-21 09:55:32
*
******************************************************************************/
type FilterDataInfoDAOImplement struct {
	session *xorm.Session
	meta    *grmi.Entity
}

/******************************************************************************
*
* @Function Name            : NewFilterDataInfoDAOImplement
*-----------------------------------------------------------------------------
*
* @Description              : 创建一个FilterDataInfoDAOImplement实例
*
* @Function Parameters      : xorm会话
*

* @Return Value             : FilterDataInfoDAOImplement实例
*
* @Author                   : 代码生成器创建
*
* @Date                     : 2021-06-21 09:55:32
*
******************************************************************************/
func NewFilterDataInfoDAOImplement(session *xorm.Session) *FilterDataInfoDAOImplement {
	return &FilterDataInfoDAOImplement{session, &meta.FilterDataInfo}
}

/******************************************************************************
*
* @Reference LAPP_ACURA_MOM_BACKEND/dao/report/FilterDataInfoDAO.InsertOne
*
******************************************************************************/
func (impl *FilterDataInfoDAOImplement) InsertOne(entity *model.FilterDataInfo) error {

	_, err := impl.session.Table(impl.meta.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
*
* @Reference LAPP_ACURA_MOM_BACKEND/dao/report/FilterDataInfoDAO.DeleteOne
*
******************************************************************************/
func (impl *FilterDataInfoDAOImplement) DeleteOne() error {
	_, err := impl.session.Table(impl.meta.TableName).ID(core.PK{}).Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

/******************************************************************************
*
* @Reference LAPP_ACURA_MOM_BACKEND/dao/report/FilterDataInfoDAO.SelectOne
*
******************************************************************************/
func (impl *FilterDataInfoDAOImplement) SelectOne() (*model.FilterDataInfo, error) {
	var data model.FilterDataInfo
	ok, err := impl.session.Table(impl.meta.TableName).ID(core.PK{}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

/******************************************************************************
*
* @Reference LAPP_ACURA_MOM_BACKEND/dao/report/FilterDataInfoDAO.UpdateOne
*
******************************************************************************/
func (impl *FilterDataInfoDAOImplement) UpdateOne(entity *model.FilterDataInfo) error {

	_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
*
* @Reference LAPP_ACURA_MOM_BACKEND/dao/report/FilterDataInfoDAO.Insert
*
******************************************************************************/
func (impl *FilterDataInfoDAOImplement) Insert(entities *[]model.FilterDataInfo) error {
	_, err := impl.session.Table(impl.meta.TableName).Insert(entities)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
*
* @Reference LAPP_ACURA_MOM_BACKEND/dao/report/FilterDataInfoDAO.Delete
*
******************************************************************************/
func (impl *FilterDataInfoDAOImplement) Delete(entities *[]model.FilterDataInfo) error {
	for _, entity := range *entities {

		_, err := impl.session.Table(impl.meta.TableName).ID(entity.GetKey()).Delete(impl.meta.Indicator)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
*
* @Reference LAPP_ACURA_MOM_BACKEND/dao/report/FilterDataInfoDAO.DeleteWhere
*
******************************************************************************/
func (impl *FilterDataInfoDAOImplement) DeleteWhere(predicates []grmi.Predicate) error {

	parameters := []interface{}{}
	where := "1=1 "

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := session.Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
*
* @Reference LAPP_ACURA_MOM_BACKEND/dao/report/FilterDataInfoDAO.Select
*
******************************************************************************/
func (impl *FilterDataInfoDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.FilterDataInfo, error) {

	parameters := []interface{}{}
	where := "1=1 "

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]model.FilterDataInfo, 0, 10)
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
*
* @Reference LAPP_ACURA_MOM_BACKEND/dao/report/FilterDataInfoDAO.SelectAndPaging
*
******************************************************************************/
func (impl *FilterDataInfoDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {

	parameters := []interface{}{}
	where := "1 = 1 "

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	count, err := session.Count(impl.meta.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}

	orderBy := " order by "
	if orderByFields != nil {
		for _, field := range orderByFields {
			orderBy += ", " + field.ColumnName
		}
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.FilterDataInfo, 0, 10)
	where = " where " + where
	err = impl.session.Table(impl.meta.TableName).SQL("select * from "+impl.meta.TableName+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}

/******************************************************************************
*
* @Reference LAPP_ACURA_MOM_BACKEND/dao/report/FilterDataInfoDAO.Update
*
******************************************************************************/
func (impl *FilterDataInfoDAOImplement) Update(entities *[]model.FilterDataInfo) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]

		_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
*
* @Reference LAPP_ACURA_MOM_BACKEND/dao/report/FilterDataInfoDAO.UpdateWhere
*
******************************************************************************/
func (impl *FilterDataInfoDAOImplement) UpdateWhere(predicates []grmi.Predicate, entity *model.FilterDataInfo, columns ...string) error {

	parameters := []interface{}{}
	where := "1=1 "

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := session.Cols(columns...).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
*
* @Reference LAPP_ACURA_MOM_BACKEND/dao/report/FilterDataInfoDAO.SelectDisplayData
*
******************************************************************************/
func (impl *FilterDataInfoDAOImplement) SelectDisplayData(desc string, start string, end string) ([]model.FilterDataInfo, error) {
	session := impl.session.Table(impl.meta.TableName)
	where := fmt.Sprintf("%s = ? and %s >= ? and %s <= ?", meta.FilterDataInfo_DescCN.ColumnName, meta.FilterDataInfo_Ts.ColumnName, meta.FilterDataInfo_Ts.ColumnName)
	session = session.Where(where, desc, start, end)
	data := make([]model.FilterDataInfo, 0, 10)
	err := session.OrderBy(meta.FilterDataInfo_Ts.ColumnName).Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}
